/**
 * Name: RandomForce.cpp
 *
 * Copyright (c) 2005 University of Bournemouth
 */
#include "RandomForce.h"
using namespace GraphicsLib;
using namespace ParticleSystems;
RandomForce::RandomForce(Vector *f, float a) : Force(f, a) {
}

RandomForce::~RandomForce(){
	delete force;
}

void RandomForce::applyForce(Vector *direction) {

	if(attenuation) {
		(*direction).x += RandomNum((*force).x);
		(*direction).y += RandomNum((*force).y);
		(*direction).z += RandomNum((*force).z);
		(*direction).w += RandomNum((*force).w);
	} else {
		(*direction).x += (attenuation * RandomNum((*force).x));
		(*direction).y += (attenuation * RandomNum((*force).y));
		(*direction).z += (attenuation * RandomNum((*force).z));
		(*direction).w += (attenuation * RandomNum((*force).w));
	}
}

void RandomForce::applyForce(GraphicsLib::Vector *direction, float *mass) {
	//if attenuation == 1 apply it fully
	if(attenuation) {
		(*direction).x += (RandomNum((*force).x))/(*mass);
		(*direction).y += (RandomNum((*force).y))/(*mass);
		(*direction).z += (RandomNum((*force).z))/(*mass);
		(*direction).w += (RandomNum((*force).w))/(*mass);
	} else {
		(*direction).x += (attenuation * RandomNum((*force).x))/(*mass);
		(*direction).y += (attenuation * RandomNum((*force).y))/(*mass);
		(*direction).z += (attenuation * RandomNum((*force).z))/(*mass);
		(*direction).w += (attenuation * RandomNum((*force).w))/(*mass);
	}
}
