/**
 * Name: StrikeParticle.cpp
 *
 * Copyright (c) 2005 University of Bournemouth
 */
#include "StrikeParticle.h"

using namespace GraphicsLib;
using namespace ParticleSystems;


StrikeParticle::StrikeParticle(int sysId, Solver *sol) : Particle(sysId,sol) {
	old_Position = position;
}

StrikeParticle::StrikeParticle(	int sysId, 
							Solver *sol, 
							Point3 pos, 
							Vector vel, 
							Colour c, 
							Colour fc,
							GLfloat s,
							GLfloat fs, 
							GLfloat ml) : Particle(sysId, sol, pos, vel, c,fc,s ,fs ,ml) {
	old_Position = position;
	
}

void StrikeParticle::draw(void) {
   
	glPushMatrix();
		// define the particles colour
		colour.Use();
		//draw the strike
		glBegin(GL_LINES);
			glVertex3f(old_Position.x,old_Position.y,old_Position.z);
			glVertex3f(position.x,position.y,position.z);
		glEnd();
	glPopMatrix();
}

void StrikeParticle::update(void) {

	Vector *tmp = &velocity;
	solv->nextStep(tmp);
	#ifdef __COLLISION__
            std::cout << "In particle " << position<< std::endl;
	#endif
	//need the old_position updated first
	old_Position = position;
	position+=velocity;
	size -= flare_size;
	colour = colour - faded_colour;
	life+=1.0;
	if(life>MAXLIFE) {
		dead = true;
	}
	#ifdef __COLLISION__
            std::cout << "In particle new" << position<< std::endl;
	#endif
}

bool StrikeParticle::isDead() {
	return dead;
}


StrikeParticle::~StrikeParticle() {

}
